/*
 Pokus s posíláním na Raspberry - tam spustit lora_test.py
 
 Ebyte 1PCS E32-868T20D DIP 20dBm 3km SX1276 868MHz LoRa rf 
 this example shows how to send data to an EBYTE transceiver. 
 note you will need to have both transmiter and receiver frequences set to the same channel.
 if using and Arduino, you may need 4k7 pullups or inline resistors

- doplněno o tlakové čidlo

-  18.12.2019 - předěláno dle vyrobeného PCB

*/



#include <SoftwareSerial.h>
#include "EBYTE.h"
#include "src/LowPower/LowPower.h"
#include "src/interval/interval.h"
#include <Wire.h>
#include <Adafruit_BMP085.h>
#include <DallasTemperature.h>
#include "DHT.h"

//#include <LiquidCrystal_I2C.h>



//LiquidCrystal_I2C lcd(0x27,16,4);  // set the LCD address to 0x27 for a 16 chars and 2 line display

#define GOLOWPOWER() LowPower.idle(SLEEP_8S, ADC_OFF, TIMER2_OFF, TIMER1_OFF, TIMER0_ON, SPI_OFF, USART0_OFF, TWI_OFF)

#define ADDR_FROM  0xBB
#define ADDR_TO    0xAA
#define MAGIC_BYTE 0xAB

#define M0          5 // modul Ebyte
#define M1          6 // modul Ebyte
#define AUX         9 // modul Ebyte
#define DHTPIN     A3 // DHT22 vlhkoměr 1wire
#define teplomer   A2 // DS18B20 1wire
#define pinDest     2 // 2 - srážky int0
#define MOSFET      4 // MOSFET, který spíná napaájení pro čidla
#define RX          8 // 
#define TX          7 // 

#define DHTTYPE  DHT11 //DHT22  // použitý vlhkoměr (další typy DHT11,DHT21)


byte i;
volatile byte         dest=0;
volatile unsigned int dest_pulsy=0;


// this is a simple data structure used to send/receive data, edit to your needs
// you can send byte by byte and parse as needed, but that can be problematic
// I highly recommend sending dat via a structure

struct DATA {
  byte magicky_byte = MAGIC_BYTE;
  byte adresa_to    = ADDR_TO;
  byte adresa_od    = ADDR_FROM;
  byte delka =8; //delka následující zprávy (dat)v Bytech
  unsigned long Count;
  unsigned long milisekundy;
};

// create a data structure
DATA MyData;


SoftwareSerial ESerial(RX,TX); //první parametr je Rx takže jde na Tx vysílače, druhý parametr je Tx takže jde na Rx vysílače


// Now you MUST create the transceiver object and you must pass in the serail object use the & to pass by reference
// usage for teensy is the exact same
// M0, M1, and Aux pins are next
EBYTE Transceiver(&ESerial, M0,M1,AUX);

Adafruit_BMP085 bmp;
OneWire oneWire(teplomer);
DallasTemperature DS18B20(&oneWire);

DHT dht(DHTPIN, DHTTYPE);

void setup() {
  pinMode(M0, OUTPUT);
  pinMode(M1, OUTPUT);
  pinMode(AUX, INPUT);
  pinMode(pinDest, INPUT_PULLUP);
  pinMode(MOSFET, OUTPUT);

  digitalWrite(MOSFET, LOW);
  
  Serial.begin(9600);
  Serial.println("Setup");
  delay(5000);
  
 
// you MUST begin the serial baud rate for the EBYTE device, you can send data to the EBYTE at faster rates, but you can only program it at 9600
// at least older units could only be programmed at 9600
  ESerial.begin(9600);
  Serial.println("Starting Sender");
    
// you must initialize the transceiver
// this function will extract all the operating parameters so if changes are made to only 1, all existing parameters are reused
  Transceiver.init();
  
  // unless you are changing the factory settings you need not call any of these functions. Units will work out of the box and let you send and receive data
  // Transceiver.SetAirDataRate(ADR_8K);   // change the air data rate
  // Transceiver.SetAddressH(0);    // set the high address byte
  // Transceiver.SetAddressL(0);    // set the low address byte
  // Transceiver.SetChannel(2);     // set the channel (0-32 is pretty typical)
  // Transceiver.SaveParameters(PERMANENT); // save the parameters to the EBYTE EEPROM, you can save temp if periodic changes are needed

   // if you want to see the units settings, otherwise never need to call this
   Transceiver.PrintParameters();

  if (!bmp.begin()) {
  Serial.println("Could not find a valid BMP085 sensor, check wiring!");
   while (1) {}
  }
  else
  Serial.println("BMP inivializováno"); 
   //lcd.init();                      // initialize the lcd 
 
  DS18B20.begin();
  dht.begin();
  attachInterrupt(0,preruseni_dest, FALLING ); //PIN 2 je Int 0
}

void preruseni_dest() {
    dest = 1;
    dest_pulsy++;
}

void loop() {
 
 ESerial.begin(9600);
 Serial.print("Temperature BMP = ");
 Serial.print(bmp.readTemperature());
 Serial.println(" *C");
    
 Serial.print("Pressure = ");
 Serial.print(bmp.readPressure());
 Serial.println(" Pa");
 Serial.println();
 
 // mereni teploty
 Serial.print("pocet cidel:");Serial.println(DS18B20.getDeviceCount());   
 int i=0;
 float Teplota=85;
 while ((Teplota == 85 || Teplota == -127) && i<= 3)
 {
     i++;
     Serial.println("ctu teplotu");
     DS18B20.requestTemperatures();
     Teplota = DS18B20.getTempCByIndex(0);
     delay(5);
 } 
 
  Serial.println(Teplota);
  Serial.println();

  float h = dht.readHumidity();
  float t = dht.readTemperature();
  float f = dht.readTemperature(true);

  if (isnan(h) || isnan(t) || isnan(f)) {
    Serial.println(F("Failed to read from DHT sensor!"));
  }

  float hif = dht.computeHeatIndex(f, h);
  float hic = dht.computeHeatIndex(t, h, false);

  Serial.print(F("Humidity: "));
  Serial.print(h);
  Serial.print(F("%  Temperature: "));
  Serial.print(t);
  Serial.print(F("°C "));
  Serial.print(f);
  Serial.print(F("°F  Heat index: "));
  Serial.print(hic);
  Serial.print(F("°C "));
  Serial.print(hif);
  Serial.println(F("°F"));
  Serial.println();
  
  detachInterrupt(0); // pred ctenim musime zakazat preruseni
  unsigned int dest_pulsy_posledni =dest_pulsy;
  dest_pulsy=0;
  attachInterrupt(0,preruseni_dest, FALLING );// po cteni a vynulovani ho opet povolime
  Serial.print("dest: ");;Serial.println(dest);
  Serial.print("dest pulsy: ");;Serial.println(dest_pulsy_posledni);
  if (dest==1)
   dest=0;
  Serial.println(); 
   i++;
  MyData.Count++;
  MyData.milisekundy =millis();
  Serial.println("odesilamr");
  // one simple call to send the data structure, note the mandatory use of the & for reference passing
  //Wire.write((const uint8_t*)&d, sizeof(long));

 
  Transceiver.SetMode(MODE_NORMAL);
  Transceiver.SendStruct((const uint8_t*)&MyData, sizeof(MyData));
  Serial.println("jdu cekat");
  Serial.print("AUX:");Serial.println(digitalRead(AUX));
  ESerial.flush();
  ESerial.end();
  Transceiver.SetMode(MODE_PROGRAM);
  //Transceiver.Reset();
  Serial.print("M0:");Serial.println(digitalRead(M0));
  Serial.print("M1:");Serial.println(digitalRead(M1));
  
  Serial.println("----------------------------------");
  digitalWrite(MOSFET, HIGH);
  delay(1000);
  for (int i=1; i<=1333; i++) //když chci časovat a mám povolené přerušení, tak použít nízké hodnoty, protože přerušení vlastně vymaže (přeruší)  jedno spaní
    LowPower.powerDown(SLEEP_15MS, ADC_OFF, BOD_OFF);  //SLEEP_8S Toto je uspornejsi a to řádově, ale neni k dispozici timer0 a tedy millis 15 ms, 30 ms, 60 ms, 120 ms, 250 ms, 500 ms, 1 s, 2 s, 4 s, 8 s

  digitalWrite(MOSFET, LOW);
  
}
